Index: /LMDZ5/branches/testing/libf/phylmd/test_disvert_m.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/test_disvert_m.F90	(revision 2056)
+++ /LMDZ5/branches/testing/libf/phylmd/test_disvert_m.F90	(revision 2056)
@@ -0,0 +1,70 @@
+module test_disvert_m
+
+  implicit none
+
+contains
+
+  subroutine test_disvert
+
+    ! Author: Lionel GUEZ
+
+    ! This procedure tests the order of pressure values at half-levels
+    ! and full levels. We arbitrarily choose to test ngrid values of
+    ! the surface pressure, which sample possible values on Earth.
+
+    use exner_hyb_m, only: exner_hyb
+
+    ! For llm:
+    include "dimensions.h"
+
+    ! For ap, bp, preff:
+    include "comvert.h"
+
+    ! For kappa, cpp:
+    include "comconst.h"
+
+    ! Local:
+    integer l, i
+    integer, parameter:: ngrid = 7
+    real p(ngrid, llm + 1) ! pressure at half-level, in Pa
+    real pks(ngrid) ! exner function at the surface, in J K-1 kg-1 
+    real pk(ngrid, llm) ! exner function at full level, in J K-1 kg-1 
+    real ps(ngrid) ! surface pressure, in Pa
+    real p_lay(ngrid, llm) ! pressure at full level, in Pa
+    real delta_ps ! in Pa
+
+    !---------------------
+
+    print *, "Call sequence information: test_disvert"
+
+    delta_ps = 6e4 / (ngrid - 1)
+    ps = (/(5e4 + delta_ps * i, i = 0, ngrid - 1)/)
+    forall (l = 1: llm + 1) p(:, l) = ap(l) + bp(l) * ps
+    call exner_hyb(ngrid, ps, p, pks, pk)
+    p_lay = preff * (pk / cpp)**(1. / kappa)
+
+    ! Are pressure values in the right order?
+    if (any(p(:, :llm) <= p_lay .or. p_lay <= p(:, 2:))) then
+       ! List details and stop:
+       do l = 1, llm
+          do i = 1, ngrid
+             if (p(i, l) <= p_lay(i, l)) then
+                print 1000, "ps = ", ps(i) / 100., "hPa, p(level ",  l, &
+                     ") = ", p(i, l) / 100., " hPa <= p(layer ", l, ") = ", &
+                     p_lay(i, l) / 100., " hPa"
+             end if
+             if (p_lay(i, l) <= p(i, l + 1)) then
+                print 1000, "ps = ", ps(i) / 100., "hPa, p(layer ", l, ") = ", &
+                     p_lay(i, l) / 100., " hPa <= p(level ", l + 1, ") = ", &
+                     p(i, l + 1) / 100., " hPa"
+             end if
+          end do
+       end do
+       call abort_gcm("test_disvert", "bad order of pressure values", 1)
+    end if
+
+1000 format (3(a, g10.4, a, i0))
+
+  end subroutine test_disvert
+
+end module test_disvert_m
Index: /LMDZ5/branches/testing/libf/phylmd/thermcell.h
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/thermcell.h	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/thermcell.h	(revision 2056)
@@ -9,13 +9,13 @@
       real,parameter     :: r_aspect_thermals=2.,l_mix_thermals=30.
       real               :: alp_bl_k
-      real               :: tau_thermals
+      real               :: tau_thermals,fact_thermals_ed_dz
       integer,parameter  :: w2di_thermals=0
       integer            :: isplit
 
       integer            :: iflag_coupl,iflag_clos,iflag_wake
-      integer            :: iflag_thermals_ed,iflag_thermals_optflux
+      integer            :: iflag_thermals_ed,iflag_thermals_optflux,iflag_thermals_closure
 
-      common/ctherm1/iflag_thermals,nsplit_thermals
-      common/ctherm2/tau_thermals,alp_bl_k
+      common/ctherm1/iflag_thermals,nsplit_thermals,iflag_thermals_closure
+      common/ctherm2/tau_thermals,alp_bl_k,fact_thermals_ed_dz
       common/ctherm4/iflag_coupl,iflag_clos,iflag_wake
       common/ctherm5/iflag_thermals_ed,iflag_thermals_optflux
Index: /LMDZ5/branches/testing/libf/phylmd/thermcell_dry.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/thermcell_dry.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/thermcell_dry.F90	(revision 2056)
@@ -122,6 +122,13 @@
                zw2(ig,l+1)=0.
                lmax(ig)=l
+!            endif
+!CR:zmax continu 06/05/12: calcul de linter quand le thermique est stoppe par le detrainement
+            elseif (f_star(ig,l+1).lt.0.) then
+               linter(ig)=(l*(f_star(ig,l+1)-f_star(ig,l))  &
+     &           -f_star(ig,l))/(f_star(ig,l+1)-f_star(ig,l))
+               zw2(ig,l+1)=0.
+               lmax(ig)=l
             endif
-
+!CRfin
                wa_moy(ig,l+1)=sqrt(zw2(ig,l+1))
 
Index: /LMDZ5/branches/testing/libf/phylmd/thermcell_height.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/thermcell_height.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/thermcell_height.F90	(revision 2056)
@@ -84,6 +84,7 @@
       enddo
 
-      if (iflag_thermals_ed.ge.1) then
-
+!     if (iflag_thermals_ed.ge.1) then
+      if (1==0) then
+!CR:date de quand le calcul du zmax continu etait buggue 
          num(:)=0.
          denom(:)=0.
@@ -100,7 +101,7 @@
        endif 
        enddo
-
-       else
-
+ 
+      else
+!CR:Calcul de zmax continu via le linter      
       do  ig=1,ngrid
 ! calcul de zlevinter
Index: /LMDZ5/branches/testing/libf/phylmd/thermcell_main.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/thermcell_main.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/thermcell_main.F90	(revision 2056)
@@ -513,4 +513,5 @@
     &                      lalim,lmin,zmax_sec,wmax_sec,lev_out)
 
+ 
 call test_ltherm(ngrid,nlay,pplev,pplay,lmin,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_dry  lmin  ')
 call test_ltherm(ngrid,nlay,pplev,pplay,lalim,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_dry  lalim ')
@@ -533,6 +534,8 @@
       alim_star_clos(:,:)=alim_star(:,:)
       alim_star_clos(:,:)=entr_star(:,:)+alim_star(:,:)
-
-! Appel avec la version seche
+!
+!CR Appel de la fermeture seche 
+      if (iflag_thermals_closure.eq.1) then
+
       CALL thermcell_closure(ngrid,nlay,r_aspect_thermals,ptimestep,rho,  &
      &   zlev,lalim,alim_star_clos,f_star,zmax_sec,wmax_sec,f,lev_out)
@@ -541,6 +544,11 @@
 ! Appel avec les zmax et wmax tenant compte de la condensation
 ! Semble moins bien marcher
-!     CALL thermcell_closure(ngrid,nlay,r_aspect_thermals,ptimestep,rho,  &
-!    &   zlev,lalim,alim_star,f_star,zmax,wmax,f,lev_out)
+     else if (iflag_thermals_closure.eq.2) then
+
+     CALL thermcell_closure(ngrid,nlay,r_aspect_thermals,ptimestep,rho,  &
+    &   zlev,lalim,alim_star,f_star,zmax,wmax,f,lev_out)
+
+     endif
+
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
@@ -754,7 +762,12 @@
       do ig=1,ngrid
         if (ok_lcl(ig)) then 
-          if ((pplay(ig,l) .ge. pcon(ig)) .and. (pplay(ig,l+1) .le. pcon(ig))) then
+!ATTENTION,zw2 calcule en pplev
+!          if ((pplay(ig,l) .ge. pcon(ig)) .and. (pplay(ig,l+1) .le. pcon(ig))) then
+!          klcl(ig)=l
+!          interp(ig)=(pcon(ig)-pplay(ig,klcl(ig)))/(pplay(ig,klcl(ig)+1)-pplay(ig,klcl(ig)))
+!          endif
+          if ((pplev(ig,l) .ge. pcon(ig)) .and. (pplev(ig,l+1) .le. pcon(ig))) then
           klcl(ig)=l
-          interp(ig)=(pcon(ig)-pplay(ig,klcl(ig)))/(pplay(ig,klcl(ig)+1)-pplay(ig,klcl(ig)))
+          interp(ig)=(pcon(ig)-pplev(ig,klcl(ig)))/(pplev(ig,klcl(ig)+1)-pplev(ig,klcl(ig)))
           endif
         endif
@@ -772,5 +785,6 @@
 !!    enddo
     do ig =1,ngrid
-     zmax(ig)=pphi(ig,lmax(ig))/rg
+!CR:REHABILITATION ZMAX CONTINU
+!     zmax(ig)=pphi(ig,lmax(ig))/rg
      if (ok_lcl(ig)) then 
       rhobarz0(ig)=rhobarz(ig,klcl(ig))+(rhobarz(ig,klcl(ig)+1) &
@@ -915,5 +929,5 @@
 !------------Closure------------------
 
-  IF (iflag_clos_bl.ge.1) THEN 
+  IF (iflag_clos_bl.ge.2) THEN 
 
 !-----Calcul de ALP_BL_STAT
@@ -938,5 +952,5 @@
   enddo
 
-  ENDIF ! (iflag_clos_bl.ge.1)
+  ENDIF ! (iflag_clos_bl.ge.2)
 
 !!! fin nrlmd le 10/04/2012
Index: /LMDZ5/branches/testing/libf/phylmd/thermcell_plume.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/thermcell_plume.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/thermcell_plume.F90	(revision 2056)
@@ -7,9 +7,6 @@
      &           ztla,zqla,zqta,zha,zw2,w_est,ztva_est,zqsatth,lmix,lmix_bis,linter &
      &           ,lev_out,lunout1,igout)
-
 !--------------------------------------------------------------------------
-! thermcell_plume: calcule les valeurs de qt, thetal et w dans l ascendance
-! Last modified : Arnaud Jam 2014/02/11
-!                 Better representation of stratocumulus
+!thermcell_plume: calcule les valeurs de qt, thetal et w dans l ascendance
 !--------------------------------------------------------------------------
 
@@ -83,4 +80,7 @@
       real zbuoyjam(ngrid,klev)
       real zbuoybis,zdz2,zdz3,lmel,entrbis,zdzbis
+      real fact_shell
+      real ztv1,ztv2,factinv,zinv,zlmel
+      real ztv_est1,ztv_est2
       real zcor,zdelta,zcvm5,qlbef
       real betalpha,zbetalpha
@@ -98,5 +98,6 @@
       fact_epsilon=0.002
       betalpha=0.9 
-      afact=2./3.            
+      afact=2./3.    
+      fact_shell=0.85       
 
       zbetalpha=betalpha/(1.+betalpha)
@@ -164,5 +165,5 @@
                lalim(ig)=l+1
                alim_star_tot(ig)=alim_star_tot(ig)+alim_star(ig,l)
-!              print*,'alim2',l,ztv(ig,l),ztv(ig,l+1),alim_star(ig,l)
+!               print*,'alim2',l,ztv(ig,l),ztv(ig,l+1),alim_star(ig,l)
             endif
          enddo
@@ -234,5 +235,5 @@
    call thermcell_qsat(ngrid,active,pplev(:,l),ztemp,zqta(:,l-1),zqsat(:))
     do ig=1,ngrid 
-!      print*,'active',active(ig),ig,l
+!       print*,'active',active(ig),ig,l
         if(active(ig)) then 
         zqla_est(ig,l)=max(0.,zqta(ig,l-1)-zqsat(ig))
@@ -260,11 +261,46 @@
 !    &                     Max(0.0001,exp(-zw2factbis)*(w_est(ig,l-1)-zdw2bis)+zdw2)
 !              w_est(ig,l+1)=Max(0.0001,(1-exp(-zw2fact))*zdw2+w_est(ig,l)*exp(-zw2fact))
+
+!--------------------------------------------------
+!AJ052014: J'ai remplac? w_est(ig,l) par zw2(ig,l)
+!--------------------------------------------------
+         if (iflag_thermals_ed==8) then
+! Ancienne version
              w_est(ig,l+1)=Max(0.0001,(zdz/zdzbis)*(exp(-zw2fact)* &
     &                     (w_est(ig,l)-zdw2)+zdw2)+(zdzbis-zdz)/zdzbis* &
     &                     (exp(-zw2factbis)*(w_est(ig,l-1)-zdw2bis)+zdw2))
-             if (w_est(ig,l+1).lt.0.) then
+ 
+! Nouvelle version Arnaud
+         else
+              w_est(ig,l+1)=Max(0.0001,(zdz/zdzbis)*(exp(-zw2fact)* &
+    &                     (zw2(ig,l)-zdw2)+zdw2)+(zdzbis-zdz)/zdzbis* &
+    &                     (exp(-zw2factbis)*(zw2(ig,l-1)-zdw2bis)+zdw2))
+         endif
+
+
+         if (iflag_thermals_ed<6) then
+             zalpha=f0(ig)*f_star(ig,l)/sqrt(w_est(ig,l+1))/rhobarz(ig,l)
+!              fact_epsilon=0.0005/(zalpha+0.025)**0.5
+!              fact_epsilon=Min(0.003,0.0004/(zalpha)**0.5)
+              fact_epsilon=0.0002/(zalpha+0.1)
+              zw2fact=fact_epsilon*2.*zdz/(1.+betalpha)
+              zw2factbis=fact_epsilon*2.*zdzbis/(1.+betalpha)
+              zdw2=afact*zbuoy(ig,l)/fact_epsilon
+              zdw2bis=afact*zbuoy(ig,l-1)/fact_epsilon
+              w_est(ig,l+1)=Max(0.0001,(zdz/zdzbis)*(exp(-zw2fact)* &
+    &                     (zw2(ig,l)-zdw2)+zdw2)+(zdzbis-zdz)/zdzbis* &
+    &                     (exp(-zw2factbis)*(zw2(ig,l-1)-zdw2bis)+zdw2))
+
+         endif
+!--------------------------------------------------
+!AJ052014: J'ai comment? ce if plus n?cessaire puisqu'
+!on fait max(0.0001,.....)
+!--------------------------------------------------	 
+
+!             if (w_est(ig,l+1).lt.0.) then
 !               w_est(ig,l+1)=zw2(ig,l)
-                w_est(ig,l+1)=0.0001
-             endif
+!                w_est(ig,l+1)=0.0001
+!             endif
+
        endif
     enddo
@@ -297,13 +333,115 @@
 !Modif AJAM
           
-	lmel=0.1*zlev(ig,l)
+	lmel=fact_thermals_ed_dz*zlev(ig,l)
+        zlmel=zlev(ig,l)+lmel
 !        lmel=2.5*(zlev(ig,l)-zlev(ig,l-1))
         lt=l+1
-         do it=1,klev-(l+1) 
-          zdz2=zlev(ig,lt)-zlev(ig,l)
-          if (zdz2.gt.lmel) then 
-          zdz3=zlev(ig,lt)-zlev(ig,lt-1) 
+        zdz2=zlev(ig,lt)-zlev(ig,l)
+!--------------------------------------------------
+!AJ052014: J'ai remplac? la boucle do par un do while
+! afin de faire moins de calcul dans la boucle
+!--------------------------------------------------
+         do while (zdz2.lt.lmel)
+         lt=lt+1
+         zdz2=zlev(ig,lt)-zlev(ig,l)
+         end do
+
+         zdz3=zlev(ig,lt)-zlev(ig,lt-1) 
+
+!--------------------------------------------------
+!AJ052014: Si iflag_thermals_ed<8 (par ex 6), alors
+! on cherche o? se trouve l'altitude d'inversion 
+! en calculant ztv1 (interpolation de la valeur de 
+! theta au niveau lt en utilisant les niveaux lt-1 et
+! lt-2) et ztv2 (interpolation avec les niveaux lt+1
+! et lt+2). Si theta r?ellement calcul?e au niveau lt
+! comprise entre ztv1 et ztv2, alors il y a inversion
+! et on calcule son altitude zinv en supposant que ztv(lt)
+! est une combinaison lin?aire de ztv1 et ztv2.
+! Ensuite, on calcule la flottabilit? en comparant 
+! la temp?rature de la couche l ? celle de l'air situ? 
+! l+lmel plus haut, ce qui n?cessite de savoir quel fraction 
+! de cet air est au-dessus ou en-dessous de l'inversion   
+!--------------------------------------------------
+
+
+	 if (iflag_thermals_ed.lt.8) then
+
+          ztv1=(ztv(ig,lt-1)-ztv(ig,lt-2))*zlev(ig,lt)/(zlev(ig,lt-1)-zlev(ig,lt-2)) &
+    &          +(ztv(ig,lt-2)*zlev(ig,lt-1)-ztv(ig,lt-1)*zlev(ig,lt-2)) &
+    &          /(zlev(ig,lt-1)-zlev(ig,lt-2))
+
+          ztv2=(ztv(ig,lt+2)-ztv(ig,lt+1))*zlev(ig,lt)/(zlev(ig,lt+2)-zlev(ig,lt+1)) &
+    &          +(ztv(ig,lt+1)*zlev(ig,lt+2)-ztv(ig,lt+2)*zlev(ig,lt+1)) &
+    &          /(zlev(ig,lt+2)-zlev(ig,lt+1))
+
+          if (ztv(ig,lt).gt.ztv1.and.ztv(ig,lt).lt.ztv2) then  
+
+	  factinv=(ztv2-ztv(ig,lt))/(ztv2-ztv1)
+          zinv=zlev(ig,lt-1)+factinv*(zlev(ig,lt)-zlev(ig,lt-1))
+
+	  if (zlmel+0.5*zdz.ge.zinv) then
+           if (zlmel-0.5*zdz.ge.zinv) then
+
+          ztv_est(ig,l)=(ztv(ig,lt+2)-ztv(ig,lt+1))*(zlmel-0.*zdz)/(zlev(ig,lt+2)-zlev(ig,lt+1)) &
+    &          +(ztv(ig,lt+1)*zlev(ig,lt+2)-ztv(ig,lt+2)*zlev(ig,lt+1)) &
+    &          /(zlev(ig,lt+2)-zlev(ig,lt+1))
+
+          zbuoyjam(ig,l)=fact_shell*RG*(ztva_est(ig,l)-ztv_est(ig,l))/ztv_est(ig,l)+(1.-fact_shell)*zbuoy(ig,l)
+
+          else
+
+	  ztv_est1=(ztv(ig,lt+2)-ztv(ig,lt+1))*0.5*(zlmel+zinv+0.5*zdz)/(zlev(ig,lt+2)-zlev(ig,lt+1)) &
+    &          +(ztv(ig,lt+1)*zlev(ig,lt+2)-ztv(ig,lt+2)*zlev(ig,lt+1)) &
+    &          /(zlev(ig,lt+2)-zlev(ig,lt+1))
+          ztv_est2=(ztv(ig,lt-1)-ztv(ig,lt-2))*0.5*(zinv+zlmel-0.5*zdz)/(zlev(ig,lt-1)-zlev(ig,lt-2)) &
+    &          +(ztv(ig,lt-2)*zlev(ig,lt-1)-ztv(ig,lt-1)*zlev(ig,lt-2)) &
+    &          /(zlev(ig,lt-1)-zlev(ig,lt-2))
+          zbuoyjam(ig,l)=fact_shell*RG*(((zlmel+0.5*zdz-zinv)/zdz)*(ztva_est(ig,l)- & 
+    &          ztv_est1)/ztv_est1+((zinv-zlmel+0.5*zdz)/zdz)*(ztva_est(ig,l)- &
+    &          ztv_est2)/ztv_est2)+(1.-fact_shell)*zbuoy(ig,l)
+
+           endif
+
+          else 
+
+          ztv_est(ig,l)=(ztv(ig,lt-1)-ztv(ig,lt-2))*(zlmel-0.*zdz)/(zlev(ig,lt-1)-zlev(ig,lt-2)) &
+    &          +(ztv(ig,lt-2)*zlev(ig,lt-1)-ztv(ig,lt-1)*zlev(ig,lt-2)) &
+    &          /(zlev(ig,lt-1)-zlev(ig,lt-2))
+
+          zbuoyjam(ig,l)=fact_shell*RG*(ztva_est(ig,l)-ztv_est(ig,l))/ztv_est(ig,l)+(1.-fact_shell)*zbuoy(ig,l)
+!	  ztv_est1=(ztv(ig,lt+2)-ztv(ig,lt+1))*0.5*(zlmel+zinv+0.5*zdz)/(zlev(ig,lt+2)-zlev(ig,lt+1)) &
+!    &          +(ztv(ig,lt+1)*zlev(ig,lt+2)-ztv(ig,lt+2)*zlev(ig,lt+1)) &
+!    &          /(zlev(ig,lt+2)-zlev(ig,lt+1))
+!          ztv_est2=(ztv(ig,lt-1)-ztv(ig,lt-2))*0.5*(zinv+zlmel-0.5*zdz)/(zlev(ig,lt-1)-zlev(ig,lt-2)) &
+!    &          +(ztv(ig,lt-2)*zlev(ig,lt-1)-ztv(ig,lt-1)*zlev(ig,lt-2)) &
+!    &          /(zlev(ig,lt-1)-zlev(ig,lt-2))
+!          zbuoyjam(ig,l)=fact_shell*RG*(((zlmel+0.5*zdz-zinv)/zdz)*(ztva_est(ig,l)- & 
+!    &          ztv_est1)/ztv_est1+((zinv-zlmel+0.5*zdz)/zdz)*(ztva_est(ig,l)- &
+!    &          ztv_est2)/ztv_est2)+(1.-fact_shell)*zbuoy(ig,l)
+
+
+
+
+!          print*,'on est pass? par l?',l,lt,zbuoyjam(ig,l),zbuoy(ig,l)
+          endif
+
+
+          else
+          
 !          ztv_est(ig,l)=(lmel/zdz2)*(ztv(ig,lt)-ztv(ig,l))+ztv(ig,l)
 !          zbuoyjam(ig,l)=RG*(ztva_est(ig,l)-ztv_est(ig,l))/ztv_est(ig,l)
+
+         zbuoyjam(ig,l)=fact_shell*RG*(((lmel+zdz3-zdz2)/zdz3)*(ztva_est(ig,l)- & 
+    &          ztv(ig,lt))/ztv(ig,lt)+((zdz2-lmel)/zdz3)*(ztva_est(ig,l)- &
+    &          ztv(ig,lt-1))/ztv(ig,lt-1))+(1.-fact_shell)*zbuoy(ig,l)
+
+!         zdqt(ig,l)=Max(0.,((lmel+zdz3-zdz2)/zdz3)*(zqta(ig,l-1)- & 
+!    &          po(ig,lt))/po(ig,lt)+((zdz2-lmel)/zdz3)*(zqta(ig,l-1)- &
+!     &          po(ig,lt-1))/po(ig,lt-1))
+
+	  endif
+
+          else
 
          zbuoyjam(ig,l)=1.*RG*(((lmel+zdz3-zdz2)/zdz3)*(ztva_est(ig,l)- & 
@@ -311,31 +449,30 @@
     &          ztv(ig,lt-1))/ztv(ig,lt-1))+0.*zbuoy(ig,l)
 
-!         zdqt(ig,l)=Max(0.,((lmel+zdz3-zdz2)/zdz3)*(zqta(ig,l-1)- & 
-!    &          po(ig,lt))/po(ig,lt)+((zdz2-lmel)/zdz3)*(zqta(ig,l-1)- &
-!    &          po(ig,lt-1))/po(ig,lt-1))
+	  endif
           
-          else
-          lt=lt+1
-          endif
-          enddo
 
 !          zbuoyjam(ig,l)=RG*(ztva_est(ig,l)-ztv(ig,l))/ztv(ig,l)
 
+!          entr_star(ig,l)=f_star(ig,l)*zdz*zbetalpha*MAX(0.,  &
+!    &     afact*zbuoyjam(ig,l)/zw2m - fact_epsilon ) 
+
+!          entrbis=entr_star(ig,l)
+
+	  if (iflag_thermals_ed.lt.6) then
+          fact_epsilon=0.0002/(zalpha+0.1)
+	  endif
+
+          detr_star(ig,l)=f_star(ig,l)*zdz             &
+    &     *MAX(1.e-4, -afact*zbetalpha*zbuoyjam(ig,l)/zw2m          &
+    &     + 0.012*(zdqt(ig,l)/zw2m)**0.5)
+
+          zbuoy(ig,l)=RG*(ztva_est(ig,l)-ztv(ig,l))/ztv(ig,l)
+
           entr_star(ig,l)=f_star(ig,l)*zdz*zbetalpha*MAX(0.,  &
-    &     afact*zbuoyjam(ig,l)/zw2m - fact_epsilon ) 
-
-          entrbis=entr_star(ig,l)
-
-
-          detr_star(ig,l)=f_star(ig,l)*zdz                        &
-    &     *MAX(1.e-4, -afact*zbetalpha*zbuoyjam(ig,l)/zw2m          &
-    &     + 0.012*(zdqt(ig,l)/zw2m)**0.5 )
-
-
-!           zbuoy(ig,l)=RG*(ztva_est(ig,l)-ztv(ig,l))/ztv(ig,l)
-!
-!           entr_star(ig,l)=Max(0.,f_star(ig,l)*zdz*zbetalpha*  &     
-!     &     afact*zbuoy(ig,l)/zw2m &
-!     &     - 1.*fact_epsilon)
+    &     afact*zbuoy(ig,l)/zw2m - fact_epsilon)
+
+!          entr_star(ig,l)=Max(0.,f_star(ig,l)*zdz*zbetalpha*  &     
+!    &     afact*zbuoy(ig,l)/zw2m &
+!    &     - 1.*fact_epsilon)
 
           
@@ -350,5 +487,5 @@
 !        endif
 
-!print*,'alim0',l,lalim(ig),alim_star(ig,l),entrbis,f_star(ig,l)
+!	print*,'alim0',zlev(ig,l),entr_star(ig,l),detr_star(ig,l),zw2m,zbuoy(ig,l),f_star(ig,l)
 ! Calcul du flux montant normalise
       f_star(ig,l+1)=f_star(ig,l)+alim_star(ig,l)+entr_star(ig,l)  &
@@ -393,5 +530,5 @@
            zdzbis=zlev(ig,l+1)-zlev(ig,l-1)
            zeps(ig,l)=(entr_star(ig,l)+alim_star(ig,l))/(f_star(ig,l)*zdz)
-
+           fact_epsilon=0.002
             zw2fact=fact_epsilon*2.*zdz/(1.+betalpha)
             zw2factbis=fact_epsilon*2.*zdzbis/(1.+betalpha)
@@ -402,4 +539,22 @@
     &                     (zw2(ig,l)-zdw2)+zdw2)+(zdzbis-zdz)/zdzbis* &
     &                     (exp(-zw2factbis)*(zw2(ig,l-1)-zdw2bis)+zdw2))
+
+	   if (iflag_thermals_ed.lt.6) then
+           zalpha=f0(ig)*f_star(ig,l)/sqrt(zw2(ig,l+1))/rhobarz(ig,l)
+!           fact_epsilon=0.0005/(zalpha+0.025)**0.5
+!           fact_epsilon=Min(0.003,0.0004/(zalpha)**0.5)
+           fact_epsilon=0.0002/(zalpha+0.1)**1
+            zw2fact=fact_epsilon*2.*zdz/(1.+betalpha)
+            zw2factbis=fact_epsilon*2.*zdzbis/(1.+betalpha)
+            zdw2= afact*zbuoy(ig,l)/(fact_epsilon)
+            zdw2bis= afact*zbuoy(ig,l-1)/(fact_epsilon)
+
+            zw2(ig,l+1)=Max(0.0001,(zdz/zdzbis)*(exp(-zw2fact)* &
+    &                     (zw2(ig,l)-zdw2)+zdw2)+(zdzbis-zdz)/zdzbis* &
+    &                     (exp(-zw2factbis)*(zw2(ig,l-1)-zdw2bis)+zdw2))
+
+	   endif
+
+
       endif
    enddo
@@ -425,4 +580,10 @@
      &               -zw2(ig,l))/(zw2(ig,l+1)-zw2(ig,l))
            zw2(ig,l+1)=0.
+!+CR:04/05/12:correction calcul linter pour calcul de zmax continu
+        elseif (f_star(ig,l+1).lt.0.) then
+           linter(ig)=(l*(f_star(ig,l+1)-f_star(ig,l))  &
+     &               -f_star(ig,l))/(f_star(ig,l+1)-f_star(ig,l))
+           zw2(ig,l+1)=0.
+!fin CR:04/05/12
         endif
 
@@ -462,6 +623,51 @@
         if (prt_level.ge.20) print*,'coucou calcul detr 470: ig, l', ig, l
 
+#undef wrgrads_thermcell
+#ifdef wrgrads_thermcell
+         call wrgradsfi(1,klev,entr_star(igout,1:klev),'esta      ','esta      ')
+         call wrgradsfi(1,klev,detr_star(igout,1:klev),'dsta      ','dsta      ')
+         call wrgradsfi(1,klev,zbuoy(igout,1:klev),'buoy      ','buoy      ')
+         call wrgradsfi(1,klev,zdqt(igout,1:klev),'dqt      ','dqt      ')
+         call wrgradsfi(1,klev,w_est(igout,1:klev),'w_est     ','w_est     ')
+         call wrgradsfi(1,klev,w_est(igout,2:klev+1),'w_es2     ','w_es2     ')
+         call wrgradsfi(1,klev,zw2(igout,1:klev),'zw2A      ','zw2A      ')
+#endif
+
+
      return 
      end
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
 
 
@@ -536,4 +742,5 @@
       REAL zqsatth(ngrid,klev)
       REAL zta_est(ngrid,klev)
+      REAL zbuoyjam(ngrid,klev)
       REAL ztemp(ngrid),zqsat(ngrid)
       REAL zdw2
@@ -572,5 +779,5 @@
 
 ! Initialisations des variables reeles
-if (1==0) then
+if (1==1) then
       ztva(:,:)=ztv(:,:)
       ztva_est(:,:)=ztva(:,:)
@@ -598,4 +805,5 @@
       zw2(:,:)=0.
       zbuoy(:,:)=0.
+      zbuoyjam(:,:)=0.
       gamma(:,:)=0.
       zeps(:,:)=0.
@@ -862,4 +1070,16 @@
         if (prt_level.ge.20) print*,'coucou calcul detr 470: ig, l', ig, l
 
+#undef wrgrads_thermcell
+#ifdef wrgrads_thermcell
+         call wrgradsfi(1,klev,entr_star(igout,1:klev),'esta      ','esta      ')
+         call wrgradsfi(1,klev,detr_star(igout,1:klev),'dsta      ','dsta      ')
+         call wrgradsfi(1,klev,zbuoy(igout,1:klev),'buoy      ','buoy      ')
+         call wrgradsfi(1,klev,zdqt(igout,1:klev),'dqt      ','dqt      ')
+         call wrgradsfi(1,klev,w_est(igout,1:klev),'w_est     ','w_est     ')
+         call wrgradsfi(1,klev,w_est(igout,2:klev+1),'w_es2     ','w_es2     ')
+         call wrgradsfi(1,klev,zw2(igout,1:klev),'zw2A      ','zw2A      ')
+#endif
+
+
      return 
      end
Index: /LMDZ5/branches/testing/libf/phylmd/tsoilnudge.h
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/tsoilnudge.h	(revision 2056)
+++ /LMDZ5/branches/testing/libf/phylmd/tsoilnudge.h	(revision 2056)
@@ -0,0 +1,7 @@
+      logical nudge_tsoil
+      integer isoil_nudge
+      real Tsoil_nudge, tau_soil_nudge
+
+      common /tsoilnudge/ nudge_tsoil, isoil_nudge, Tsoil_nudge,        &
+     &                   tau_soil_nudge
+
Index: /LMDZ5/branches/testing/makegcm
===================================================================
--- /LMDZ5/branches/testing/makegcm	(revision 2055)
+++ /LMDZ5/branches/testing/makegcm	(revision 2056)
@@ -7,4 +7,17 @@
 # options par defaut pour la commande make
 ########################################################################
+
+echo ' '
+echo 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'
+echo 'Attention makegcm n est plus supporte par l equipe de developpement'
+echo 'Il faut maintenant utiliser ./makelmdz ou ./makelmdz_fcm              '
+echo 'Si vous tenez absolument a utiliser makegcm, editez le script et'
+echo 'retirer ces lignes (a vos risques et perils)'
+echo 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'
+echo ' '
+
+exit
+
+
 set dim="96x71x19"
 set physique=lmd
@@ -30,11 +43,11 @@
 set FC_LINUX=gfortran
 
-if ( $FC_LINUX == g95 ) then
-  set OPT_LINUX="-i4 -O3 -r8 -DNC_DOUBLE"
+if ( $FC_LINUX == gfortran ) then
+  set OPT_LINUX="-O3 -fdefault-real-8 -DNC_DOUBLE"
 else if ( $FC_LINUX == gfortran ) then
   set OPT_LINUX="-O3 -fdefault-real-8 -DNC_DOUBLE"
 else
 # pgf90 options
-  set OPT_LINUX="-O3 -i4 -r8 -DNC_DOUBLE"
+  set OPT_LINUX="-O3 -fdefault-real-8 -DNC_DOUBLE"
 endif
 
@@ -51,6 +64,6 @@
 setenv IOIPSLDIR /tmpdir/fairhead/Aqua/LMDZ20120327.trunk/modipsl/lib
 setenv MODIPSLDIR /tmpdir/fairhead/Aqua/LMDZ20120327.trunk/modipsl/lib
-setenv NCDFINC /d1/mpllmd/LMDZtesting/netcdf-4.0.1/include
-setenv NCDFLIB /d1/mpllmd/LMDZtesting/netcdf-4.0.1/lib
+setenv NCDFINC /tmpdir/fairhead/Test_install/LMDZtrunk/netcdf-4.0.1/include
+setenv NCDFLIB /tmpdir/fairhead/Test_install/LMDZtrunk/netcdf-4.0.1/lib
 
 
@@ -104,10 +117,10 @@
   if ( ! $?NCDFLIB ) then
     echo You must initialize the variable NCDFLIB in your environnement
-    echo for instance: "setenv NCDFLIB /d1/mpllmd/LMDZtesting/netcdf-4.0.1/lib
+    echo for instance: "setenv NCDFLIB /tmpdir/fairhead/Test_install/LMDZtrunk/netcdf-4.0.1/lib
     exit
   endif
   if ( ! $?NCDFINC ) then
     echo You must initialize the variable NCDFINC in your environnement
-    echo for instance: "setenv NCDFINC /d1/mpllmd/LMDZtesting/netcdf-4.0.1/include
+    echo for instance: "setenv NCDFINC /tmpdir/fairhead/Test_install/LMDZtrunk/netcdf-4.0.1/include
     exit
   endif
@@ -259,5 +272,5 @@
 else if $LINUX then
 #################
-   if ( $FC_LINUX == pgf90 || $FC_LINUX == g95 || $FC_LINUX == gfortran ) then
+   if ( $FC_LINUX == pgf90 || $FC_LINUX == gfortran || $FC_LINUX == gfortran ) then
      set optim=" $OPT_LINUX "
      set optim90=" $OPT_LINUX "
@@ -519,5 +532,5 @@
              set optim90="$optim90"" -g -ffpe-trap=invalid,zero,overflow -fbounds-check -Wall "
              set optimtru90="$optimtru90"" -ffpe-trap=invalid,zero,overflow -g -fbounds-check -Wall "
-           else if ( $FC_LINUX == 'g95' ) then
+           else if ( $FC_LINUX == 'gfortran' ) then
              set optim="$optim"" -g -fbounds-check -freal=nan -ftrace=full -Wall "
              set optim90="$optim90"" -g -fbounds-check -freal=nan -ftrace=full -Wall "
@@ -585,5 +598,5 @@
    set cppflags="$cppflags -DCPP_VEGET"
 #   set link_veget=" -lsechiba -lparameters -lstomate  "
-   set link_veget=" -lsechiba -lparameters -lstomate -lparallel -lorglob -lorchidee"
+   set link_veget=" -lsechiba -lparameters -lstomate   -lorchidee"
    if ( $XNEC || $X8BRODIE || $X6NEC) then
 #      set link_veget=" -lsxsechiba -lsxparameters -lsxstomate -lsxorglob -lsxparallel"
@@ -845,5 +858,5 @@
        set opt_link="$opt_link  -L$MODIPSLDIR $link_veget -L$NCDFLIB -lnetcdf "
      endif
-   else if ($FC_LINUX == 'g95' || $FC_LINUX == 'gfortran' ) then
+   else if ($FC_LINUX == 'gfortran' || $FC_LINUX == 'gfortran' ) then
      if ( $io == "ioipsl" ) then
        set opt_link="$opt_link -L$MODIPSLDIR $link_veget -lioipsl -L$NCDFLIB  -lnetcdf -lioipsl  -lnetcdf "
@@ -1019,7 +1032,7 @@
    set optimtru90=" $optimtru90 -module $libo "
    set optim90=" $optim90 -module $libo "
-else if ( $FC_LINUX == 'g95' ) then 
-   set optimtru90=" $optimtru90 -fmod=$libo  " 
-   set optim90=" $optim90 -fmod=$libo  "
+else if ( $FC_LINUX == 'gfortran' ) then 
+   set optimtru90=" $optimtru90 -I$libo  " 
+   set optim90=" $optim90 -I$libo  "
 else if ( $FC_LINUX == 'gfortran' ) then
    set optimtru90=" $optimtru90 -M $libo  "
Index: /LMDZ5/branches/testing/makelmdz
===================================================================
--- /LMDZ5/branches/testing/makelmdz	(revision 2055)
+++ /LMDZ5/branches/testing/makelmdz	(revision 2056)
@@ -32,15 +32,7 @@
 ## try to recognise machine and infer arch from it
 machine=`hostname`
-if [[ "$machine" == "brodie" ]]
-then
-  arch="SX8_BRODIE"
-fi
 if [[ "${machine:0:3}" == "ada" ]]
 then
   arch="X64_ADA"
-fi
-if [[ "${machine:0:6}" == "ciclad" ]]
-then
-  arch="AMD64_CICLAD"
 fi
 if [[ "${machine:0:7}" == "platine" ]]
@@ -84,5 +76,5 @@
 
 CPP_KEY="" 
-INCLUDE='-I$(LIBF)/grid -I$(LIBF)/bibio -I$(LIBF)/dyn3d_common -I$(LIBF)/filtrez -I. '
+INCLUDE='-I$(LIBF)/grid -I$(LIBF)/bibio -I$(LIBF)/filtrez -I. '
 LIB=""
 adjnt=""
@@ -167,9 +159,4 @@
 	  CPP_KEY="$CPP_KEY $2" ; shift ; shift ;;
 
-      "-adjnt")
-	  echo "not operational ... work to be done here ";exit
-	  opt_dep="$opt_dep adjnt" ; adjnt="-ladjnt -ldyn3d "
-	  optim="$optim -Dadj" ; shift ;;
-
       "-cosp")
           cosp="$2" ; shift ; shift ;;
@@ -487,49 +474,16 @@
    cp -p fxy_${grille}.h fxyprim.h
    filtre="FILTRE=$filtre"
-   INCLUDE="$INCLUDE "'-I$(LIBF)/dyn3d${FLAG_PARA} '
+   INCLUDE="$INCLUDE "'-I$(LIBF)/dyn3d${FLAG_PARA} -I$(LIBF)/dyn3d_common '
 elif (( $dimc == 2 )) ; then
    filtre="FILTRE= L_FILTRE= "
    INCLUDE="$INCLUDE "'-I$(LIBF)/dyn2d'
 elif (( $dimc == 1 )) ; then
+   CPP_KEY="$CPP_KEY CPP_1D"
    filtre="L_DYN= DYN= FILTRE= L_FILTRE= DIRMAIN=phy$physique "
-   INCLUDE="$INCLUDE "'-I$(LIBF)/dyn3d' # Pas tres propre
+   INCLUDE="$INCLUDE "'-I$(LIBF)/dyn3d -I$(LIBF)/dyn3d_common ' # Pas tres propre
 else
    echo Dimension dimc=$dimc pas prevu ; exit
 fi
 
-######################################################################
-# Creation du suffixe de la configuration
-######################################################################
-
-SUFF_NAME=_${dim_full}
-SUFF_NAME=${SUFF_NAME}_phy${physique}
-
-if [[ "$parallel" != "none" ]]
-then
-  SUFF_NAME=${SUFF_NAME}_para
-  DYN=dyn${dimc}d${paramem}
-  if [[ "$paramem" == "mem" ]]
-  then
-   SUFF_NAME=${SUFF_NAME}_${paramem}
-  fi
-else
-  SUFF_NAME=${SUFF_NAME}_seq
-  DYN=dyn${dimc}d
-fi
-
-if [[ $veget != "false" ]]
-then
-  SUFF_NAME=${SUFF_NAME}_orch
-fi
-
-if [[ $couple != "false" ]]
-then
-  SUFF_NAME=${SUFF_NAME}_couple
-fi
-
-if [[ $chimie == "INCA" ]]
-then
-  SUFF_NAME=${SUFF_NAME}_inca
-fi
 
 cd $LMDGCM
@@ -574,4 +528,6 @@
 if [[ -r $LMDGCM/libf/dyn${dimc}d${FLAG_PARA}/${code}.F90 ]]
 then
+  source_code=${code}.F90
+elif [[ -r $LMDGCM/libf/phy$physique/${code}.F90 ]] ; then
   source_code=${code}.F90
 fi
